Botan 1.10.17

Public Types | Public Member Functions | List of all members
Botan::MARS Class Reference

`#include <mars.h>`

Inheritance diagram for Botan::MARS:

## Public Types
enum |

## Public Member Functions
size_t | block_size () const
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
| MARS ()
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
virtual size_t | parallelism () const
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const

## Detailed Description

MARS, IBM's candidate for AES

Definition at line 18 of file mars.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| inherited

Definition at line 107 of file block_cipher.h.

107 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:107

## Constructor & Destructor Documentation

## ◆ MARS()

Botan::MARS::MARS | ( |  | ) |
| inline

Definition at line 28 of file mars.h.

28 : EK(40) {}

## Member Function Documentation

## ◆ block_size()

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::block_size | ( |  | ) | const
| inline virtual inherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 108 of file block_cipher.h.

108 { return BS; }

## ◆ clear()

void Botan::MARS::clear | ( |  | ) |
| inline virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 24 of file mars.h.

References Botan::zeroise().

24 { zeroise(EK); }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428

## ◆ clone()

BlockCipher* Botan::MARS::clone | ( |  | ) | const
| inline virtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 26 of file mars.h.

26 { return new MARS; }
Botan::MARS::MARS
MARS()
Definition: mars.h:28

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inline inherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::MARS::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 278 of file mars.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 4 >::BLOCK_SIZE, Botan::load_le< u32bit >(), and Botan::store_le().

279 {
280 for(size_t i = 0; i != blocks; ++i)
281 {
282 u32bit A = load_le<u32bit>(in, 3) + EK[39];
283 u32bit B = load_le<u32bit>(in, 2) + EK[38];
284 u32bit C = load_le<u32bit>(in, 1) + EK[37];
285 u32bit D = load_le<u32bit>(in, 0) + EK[36];
286
287 forward_mix(A, B, C, D);
288
289 decrypt_round(A, B, C, D, EK[35], EK[34]);
290 decrypt_round(B, C, D, A, EK[33], EK[32]);
291 decrypt_round(C, D, A, B, EK[31], EK[30]);
292 decrypt_round(D, A, B, C, EK[29], EK[28]);
293 decrypt_round(A, B, C, D, EK[27], EK[26]);
294 decrypt_round(B, C, D, A, EK[25], EK[24]);
295 decrypt_round(C, D, A, B, EK[23], EK[22]);
296 decrypt_round(D, A, B, C, EK[21], EK[20]);
297
298 decrypt_round(A, D, C, B, EK[19], EK[18]);
299 decrypt_round(B, A, D, C, EK[17], EK[16]);
300 decrypt_round(C, B, A, D, EK[15], EK[14]);
301 decrypt_round(D, C, B, A, EK[13], EK[12]);
302 decrypt_round(A, D, C, B, EK[11], EK[10]);
303 decrypt_round(B, A, D, C, EK[ 9], EK[ 8]);
304 decrypt_round(C, B, A, D, EK[ 7], EK[ 6]);
305 decrypt_round(D, C, B, A, EK[ 5], EK[ 4]);
306
307 reverse_mix(A, B, C, D);
308
309 A -= EK[3]; B -= EK[2]; C -= EK[1]; D -= EK[0];
310
311 store_le(out, D, C, B, A);
312
313 in += BLOCK_SIZE;
314 out += BLOCK_SIZE;
315 }
316 }
Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::store_le
void store_le(u16bit in, byte out[2])
Definition: loadstor.h:427
Botan::load_le< u32bit >
u32bit load_le< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:183
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::OFB::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inline inherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::MARS::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 235 of file mars.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 4 >::BLOCK_SIZE, Botan::load_le< u32bit >(), and Botan::store_le().

236 {
237 for(size_t i = 0; i != blocks; ++i)
238 {
239 u32bit A = load_le<u32bit>(in, 0) + EK[0];
240 u32bit B = load_le<u32bit>(in, 1) + EK[1];
241 u32bit C = load_le<u32bit>(in, 2) + EK[2];
242 u32bit D = load_le<u32bit>(in, 3) + EK[3];
243
244 forward_mix(A, B, C, D);
245
246 encrypt_round(A, B, C, D, EK[ 4], EK[ 5]);
247 encrypt_round(B, C, D, A, EK[ 6], EK[ 7]);
248 encrypt_round(C, D, A, B, EK[ 8], EK[ 9]);
249 encrypt_round(D, A, B, C, EK[10], EK[11]);
250 encrypt_round(A, B, C, D, EK[12], EK[13]);
251 encrypt_round(B, C, D, A, EK[14], EK[15]);
252 encrypt_round(C, D, A, B, EK[16], EK[17]);
253 encrypt_round(D, A, B, C, EK[18], EK[19]);
254
255 encrypt_round(A, D, C, B, EK[20], EK[21]);
256 encrypt_round(B, A, D, C, EK[22], EK[23]);
257 encrypt_round(C, B, A, D, EK[24], EK[25]);
258 encrypt_round(D, C, B, A, EK[26], EK[27]);
259 encrypt_round(A, D, C, B, EK[28], EK[29]);
260 encrypt_round(B, A, D, C, EK[30], EK[31]);
261 encrypt_round(C, B, A, D, EK[32], EK[33]);
262 encrypt_round(D, C, B, A, EK[34], EK[35]);
263
264 reverse_mix(A, B, C, D);
265
266 A -= EK[36]; B -= EK[37]; C -= EK[38]; D -= EK[39];
267
268 store_le(out, A, B, C, D);
269
270 in += BLOCK_SIZE;
271 out += BLOCK_SIZE;
272 }
273 }
Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::store_le
void store_le(u16bit in, byte out[2])
Definition: loadstor.h:427
Botan::load_le< u32bit >
u32bit load_le< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:183
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ key_spec()

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::key_spec | ( |  | ) | const
| inline virtual inherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 110 of file block_cipher.h.

111 {
112 return Key_Length_Specification(KMIN, KMAX, KMOD);
113 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::MARS::name | ( |  | ) | const
| inline virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 25 of file mars.h.

25 { return "MARS"; }

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inline inherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inline virtual inherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::AES_256_NI, Botan::AES_192_NI, Botan::AES_128_NI, Botan::IDEA_SSE2, Botan::Noekeon_SIMD, Botan::Serpent_SIMD, and Botan::XTEA_SIMD.

Definition at line 30 of file block_cipher.h.

30 { return 1; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), and Botan::StreamCipher_Filter::StreamCipher_Filter().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), and Botan::Lion::Lion().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/mars/mars.h
- src/block/mars/mars.cpp